# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with             gcj_support
%define section         free

%if %with gcj_support
%define gcj_support     1
%else
%define gcj_support     0
%endif

Name:           swt-gtk
Version:        3.5
Release:        0.M5.2%{?dist}
Epoch:          0
Summary:        Standard Widget Toolkit for GTK+
License:        CPL 1.0
Group:          Development/Libraries/Java
URL:            http://download.eclipse.org/eclipse/downloads/
Source0:        swt-gtk-3.5.tar.bz2
Patch0:         swt-gtk-3.5-makefile.patch
Patch1:         swt-gtk-3.5-64.patch
Patch2:         swt-ptr-cflags-64.patch
Patch3:         swt-gtk-format.patch
BuildRequires:  java-devel
BuildRequires:  jpackage-utils
BuildRequires:  pkgconfig(cairo)
BuildRequires:  pkgconfig(gnome-vfs-module-2.0)
BuildRequires:  pkgconfig(gl)
BuildRequires:  pkgconfig(glu)
BuildRequires:  pkgconfig(libgnome-2.0)
BuildRequires:  pkgconfig(libgnomeui-2.0)
BuildRequires:  pkgconfig(xt)
# FIXME: (dwalluck): Fedora is broken
%if 0
BuildRequires:  pkgconfig(xtst)
%else
BuildRequires:  %{_libdir}/pkgconfig/xtst.pc
%endif
BuildRequires:  xulrunner-devel
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The SWT component is designed to provide efficient, portable
access to the user-interface facilities of the operating systems
on which it is implemented.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1
%ifarch x86_64
%patch1 -p1
%patch2 -p0
%endif
%patch3 -p0

%{__mv} about_files/pixman-licenses.txt about_files/pixman-licenses.txt.orig
%{_bindir}/iconv -f iso-8859-1 -t utf8 -o about_files/pixman-licenses.txt about_files/pixman-licenses.txt.orig
%{__rm} about_files/pixman-licenses.txt.orig

%build
export MODEL="`/bin/uname -m`"
export JAVA_HOME="%{java_home}"
%{__make} %{?_smp_mflags} JAVA_HOME="%{java_home}" JAVAC="%{javac}" JAR="%{jar}" RM="%{__rm}" CC="%{__cc}" CXX="%{__cxx}" CFLAGS="%{optflags}" CXXFLAGS="%{optflags}"
%{javadoc} -d `pwd`/api `%{_bindir}/find -type f -name "*.java"`

%install
%{__rm} -rf %{buildroot}

# jar
%{__mkdir_p} %{buildroot}%{_jnidir}
%{__cp} -p swt-gtk-%{version}.jar %{buildroot}%{_jnidir}/%{name}-%{version}.jar
(cd %{buildroot}%{_jnidir} && for jar in *-%{version}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed}  "s|-%{version}||g"`; done)

# javadoc
%{__mkdir_p} 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -a api/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%{__mkdir_p} %{buildroot}%{_libdir}/%{name}
%{__cp} -p *.so %{buildroot}%{_libdir}/%{name}/

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
%{__rm} -rf %{buildroot}

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc about.html about_files/
%{_jnidir}/%{name}.jar
%{_jnidir}/%{name}-%{version}.jar
%{_libdir}/%{name}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Fri Mar 06 2009 David Walluck <dwalluck@redhat.com> 0:3.5-0.5.M5.2
- set SWT CFLAGS correctly on x86_64

* Thu Mar 05 2009 David  Walluck <dwalluck@redhat.com> 0:3.5-0.5.M5.1
- 3.5M5

* Fri Feb 27 2009 David Walluck <dwalluck@redhat.com> 0:3.4-1
- release
